#include <stdio.h>
#include <stdlib.h>
#define N 3
typedef const int ** B ;
double x (const int * a, const int len);
double xbr(const int *a, B pos, const int len);
typedef struct t {
    double ave;
    const int * a;
    B pos;
    const int len;
}  Tn ;
typedef Tn * T;
void xbrT( T x);

int main()
{
    int * a;
    const int * pmax_ptr;
    Tn tx = {0.0, NULL, NULL, N};/* not really important, just to show that it is possible to avoid
                                  * type casting *(int *) &t->len = N ; using t defined below,
                                  * while keeping const qualifier on certain members.
                                  * Dropping const qualifier in member len declaration
                                  * is also acceptable here. In that case, simply: t->len = N
                                  * and no use for type Tn and variable tx, T suffices. */
    T t = &tx;
    a = malloc(N*sizeof(int));
    a[0] = 1, a[1] = 2, a[2] = 2;
    printf("%f %f\n", x(a,N), xbr(a, &pmax_ptr, N));
    printf("%p %p\n", (void *) a, (void *) pmax_ptr);
    a[2] = 5;
    t->a = a ;
    t->pos = &pmax_ptr;
    xbrT(t);
    printf("%f\n%p\n", t->ave, (void *) pmax_ptr);
    free(a);
    return 0;
}

double x (const int * a, const int len) {
    double ave = 0.0;
    int i;
    for (i=0;i<len;i++) {
        ave += a[i];
    }
    ave /= len;
    return ave;
}

double xbr (const int * a, B pos, const int len) {
    double ave = 0.0;
    int i, mx = a[0];
    for (i=0;i<len;i++) {
        ave += a[i];
        if (a[i]>mx) {
            mx = a[i];
            *pos = a+i;
        }
    }
    ave /= len;
    return ave;
}

void xbrT (T x) {
    x->ave = xbr(x->a, x->pos, x->len);
    return ;
}
